Update Red Hat Copyright Notices
[nbdkit.git] / tests / test-cache-max-size.sh
bloba223aac326f977b00fd7b5a06cf0770d34f39d8b
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright Red Hat
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires_filter cache
38 # Check that this is a Linux-like system supporting /proc/$pid/fd.
39 requires test -d /proc/self/fd
40 requires qemu-io --version
41 # Need the stat, cut, tr commands from coreutils.
42 requires $STAT --version
43 requires $CUT --version
44 requires tr --version
46 sock=$(mktemp -u /tmp/nbdkit-test-sock.XXXXXX)
47 d=cache-max-size.d
48 rm -rf $d
49 mkdir -p $d
50 cleanup_fn rm -rf $d
51 cleanup_fn rm -f $sock
53 # Create a cache directory.
54 mkdir $d/cache
55 TMPDIR=$d/cache
56 export TMPDIR
58 # Create an empty base image.
59 $TRUNCATE -s 1G $d/cache-max-size.img
61 # Run nbdkit with the caching filter and a low size limit to ensure
62 # that the reclaim code is exercised.
63 start_nbdkit -P $d/cache-max-size.pid -U $sock \
64 --filter=cache \
65 file $d/cache-max-size.img \
66 cache-max-size=10M cache-on-read=true
68 # Write > 10M to the plugin.
69 qemu-io -f raw "nbd+unix://?socket=$sock" \
70 -c "w -P 0 0 10M" \
71 -c "w -P 0 20M 10M" \
72 -c "r 20M 10M" \
73 -c "r 30M 10M" \
74 -c "w -P 0 40M 10M"
76 # We can't use ‘du’ on the cache directory because the cache file is
77 # deleted by the filter, and so is only accessible via /proc/$pid/fd.
78 # Get the /proc link to the cache file, and the size of it in bytes.
79 fddir="/proc/$( cat $d/cache-max-size.pid )/fd"
80 LANG=C ls -ln $fddir ||:
81 fd="$fddir/$( LANG=C ls -ln $fddir | grep $TMPDIR/ | head -1 |
82 tr -s ' ' | $CUT -d ' ' -f 9 )"
83 $STAT -L $fd
84 size=$(( $($STAT -L -c '%b * %B' $fd) ))
86 if [ "$size" -gt $(( 11 * 1024 * 1024 )) ]; then
87 echo "$0: cache size is larger than 10M (actual size: $size bytes)"
88 exit 1